/******************************************************************************
 * Copyright (c) 2013-2014, Texas Instruments Incorporated - http://www.ti.com/
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions are met
 *       * Redistributions of source code must retain the above copyright
 *         notice, this list of conditions and the following disclaimer.
 *       * Redistributions in binary form must reproduce the above copyright
 *         notice, this list of conditions and the following disclaimer in the
 *         documentation and/or other materials provided with the distribution.
 *       * Neither the name of Texas Instruments Incorporated nor the
 *         names of its contributors may be used to endorse or promote products
 *         derived from this software without specific prior written permission
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPL
 *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABL
 *  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICE
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AN
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF T
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *****************************************************************************/

// Additional numbers for settings

#ifndef _ocl_em_init_h_
#define _ocl_em_init_h_

#define TI_EM_PUBLIC_EVENT_DSC_SIZE        (64u)
#define MY_EM_CORE_NUM                     (TI_EM_CORE_NUM)
#define MY_EM_COH_MODE                     (TI_EM_COH_MODE_ON)


#ifdef TI_EM_C6678
#define MY_EM_AP_PRIVATE_FREE_QUEUE_IDX         (1022)
#define MY_EM_CD_PRIVATE_FREE_QUEUE_IDX         (1023)
#define MY_EM_HW_QUEUE_BASE_IDX                 (1024)
#define MY_EM_FREE_QUEUE_BASE_IDX               (2048)
#define MY_EM_DMA_QUEUE_BASE_IDX                (0)
#define MY_EM_HW_SEM_IDX                        (3)
#define MY_DSP_EM_FIRST_DESC_IDX_IN_LINKING_RAM (0)
#define MY_DSP_EM_FIRST_MEMORY_REGION_IDX       (0)
#endif

#ifdef TI_EM_C6634
#define MY_EM_AP_PRIVATE_FREE_QUEUE_IDX         (7300)
#define MY_EM_CD_PRIVATE_FREE_QUEUE_IDX         (7301)
#define MY_EM_HW_QUEUE_BASE_IDX                 (6656)
#define MY_EM_FREE_QUEUE_BASE_IDX               (7302)
#define MY_EM_DMA_QUEUE_BASE_IDX                (16)
#define MY_EM_HW_SEM_IDX                        (3)
#define MY_DSP_EM_FIRST_DESC_IDX_IN_LINKING_RAM (8192)
#define MY_DSP_EM_FIRST_MEMORY_REGION_IDX       (16)
#endif


#endif /*_ocl_em_init_h_*/
